/* hanoi.c : risolve il problema delle torri di Hanoi */
#include <stdio.h>

void hanoi( int src, int dst, int tmp, int n )
{
    if ( n == 1 ) {
        printf("Sposta un disco da %d a %d\n", src, dst );
    } else {
        hanoi(src, tmp, dst, n-1);
        printf("Sposta un disco da %d a %d\n", src, dst );
        hanoi(tmp, dst, src, n-1);
    }
}

int main( void )
{
    int n;
    do {
        printf("Quanti dischi? ");
        scanf("%d", &n);
    } while (n < 1);
    hanoi(1, 3, 2, n);
    return 0;
}
