/* ricerca-binaria-ric.c - Ricerca binaria ricorsiva */
#include <stdio.h>

int ricbinaria_ric(int v[], int i, int f, int k) 
{
    if ( i > f ) {
        return -1; /* non trovato */
    } else {
        int m = (i + f) / 2;
        if (v[m] == k) {
            return m; /* trovato in posizione m */
        } else {
            if (v[m] > k) {
                return ricbinaria_ric(v, i, m-1, k);
            } else {
                return ricbinaria_ric(v, m + 1, f, k);
            }
        }
    }
}

int ricbinaria(int v[], int n, int k)  
{
    return ricbinaria_ric(v, 0, n-1, k);
}

int main( void ) 
{
    int a[] = {-1, 1, 2, 3, 7, 15, 16, 18, 20, 21};
    const int N = sizeof(a) / sizeof(a[0]);
    printf("ricerca  7 = %d\n", ricbinaria(a, N,  7));
    printf("ricerca -1 = %d\n", ricbinaria(a, N, -1));
    printf("ricerca 17 = %d\n", ricbinaria(a, N, 17));
    printf("ricerca -2 = %d\n", ricbinaria(a, N, -2));
    return 0;
}
